## sra-sdk 2.3.3

=== tools/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


TOP ?= $(shell ../build/abspath.sh ..)
MODULE = tools

include $(TOP)/build/Makefile.shell


#-------------------------------------------------------------------------------
# default
#
SUBDIRS = \
	util \
	kar \
	vdb-dump \
	sra-dump \
	sra-load \
	sra-pileup \
	bam-loader \
	fastq-loader \
	srapath \
	sra-stat \
	vdb-copy \
	vdb-config \
	align-info \
	prefetch \
	nenctool \
	nencvalid \
	vdb-decrypt \
	vdb-validate \
	sra-sort \
    cache-mgr

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS) 

#-------------------------------------------------------------------------------
# tag
#
SUBDIRS_TAG = $(addsuffix _tag,$(SUBDIRS))

tag: $(SUBDIRS_TAG)

$(SUBDIRS_TAG):
	@ $(MAKE) -C $(subst _tag,,$@) tag

.PHONY: tag $(SUBDIRS_TAG)

#-------------------------------------------------------------------------------
# pass-through
#
out debug profile release GCC ICC VC++:
	@ $(MAKE) TOP=$(TOP) -f $(TOP)/build/Makefile.env $@

.PHONY: out debug profile release GCC ICC VC++

=== libs/align/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/align

INT_LIBS = \
	libncbi-bam \
	libalign-writer \
	libalign-access \
	libalign-reader

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# libncbi-bam
#
$(ILIBDIR)/libncbi-bam: $(addprefix $(ILIBDIR)/libncbi-bam.,$(ILIBEXT))

BAM_SRC = \
	bam

BAM_OBJ = \
	$(addsuffix .$(LOBX),$(BAM_SRC))

BAM_LIB = \
	-lvfs \
	-lkfs \
	-lklib \
	-lz

$(ILIBDIR)/libncbi-bam.$(LIBX): $(BAM_OBJ)
	$(LD) --slib -o $@ $^ $(BAM_LIB)


#-------------------------------------------------------------------------------
# align-access
#
$(ILIBDIR)/libalign-access: $(addprefix $(ILIBDIR)/libalign-access.,$(ILIBEXT))

ALIGN_ACCESS_SRC = \
	align-access

ALIGN_ACCESS_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_ACCESS_SRC))

ALIGN_ACCESS_LIB = \
	-sncbi-bam \
	-lvfs \
	-lkfs \
	-dkproc \
	-lklib \
	-lz

$(ILIBDIR)/libalign-access.$(LIBX): $(ALIGN_ACCESS_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_ACCESS_LIB)

#-------------------------------------------------------------------------------
# align-reader
#
$(ILIBDIR)/libalign-reader: $(addprefix $(ILIBDIR)/libalign-reader.,$(ILIBEXT))

ALIGN_READER_SRC = \
	align_mgr \
	al_iterator \
	ref_iterator \
	pl_iterator \
	dna-reverse-cmpl \
	reference-cmn \
	reader-cmn \
	reader-refseq \
	reference \
	refseq-mgr \
	quality-quantizer

ALIGN_READER_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_READER_SRC))

ALIGN_READER_LIB = \
	-lvdb \
	-lkdb \
	-lkfg \
	-lkfs \
	-lklib \
	-lz

$(ILIBDIR)/libalign-reader.$(LIBX): $(ALIGN_READER_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_READER_LIB)

#-------------------------------------------------------------------------------
# align-writer
#
$(ILIBDIR)/libalign-writer: $(addprefix $(ILIBDIR)/libalign-writer.,$(LIBX))

ALIGN_WRITER_SRC = \
    dna-reverse-cmpl \
	reader-cmn \
	reference-cmn \
	reader-refseq \
	refseq-mgr \
	writer-cmn \
	writer-refseq \
	writer-alignment \
	writer-sequence \
	writer-ref \
	writer-reference

ALIGN_WRITER_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_WRITER_SRC))

ALIGN_WRITER_LIB = \
	-lwvdb \
	-lwkdb \
	-lkfg \
	-lkfs \
	-lklib \
	-lz

$(ILIBDIR)/libalign-writer.$(LIBX): $(ALIGN_WRITER_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_WRITER_LIB)

=== libs/ext/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/ext

include $(TOP)/build/Makefile.shell

#-------------------------------------------------------------------------------
# default
#
SUBDIRS = \
	zlib \
	bzip2 \
	curl

include $(TOP)/build/Makefile.targets

default: $(SUBDIRS)

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS)


#-------------------------------------------------------------------------------
# pass-through
#
out debug profile release GCC ICC VC++:
	@ $(MAKE) TOP=$(TOP) -f $(TOP)/build/Makefile.env $@

.PHONY: out debug profile release GCC ICC VC++

=== libs/kfg/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/kfg

INT_LIBS = \
	libkfg

ALL_LIBS = \
	$(INT_LIBS)

TEST_TOOLS = \

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: all std $(ALL_LIBS) $(TEST_TOOLS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean
	@ rm -f $(addsuffix *,$(addprefix $(TEST_BINDIR)/,$(TEST_TOOLS)))

.PHONY: clean

#-------------------------------------------------------------------------------
# kfg
#
$(ILIBDIR)/libkfg: $(TARGDIR)/default.kfg $(addprefix $(ILIBDIR)/libkfg.,$(ILIBEXT))

$(TARGDIR)/default.kfg: $(NCBIDIR)/default.kfg $(TEST_BINDIR)/ncbi/default.kfg

$(NCBIDIR)/default.kfg: $(SRCDIR)/default.kfg
	rm -f $(NCBIDIR)/config.kfg
	cp $^ $@

$(TEST_BINDIR)/ncbi/default.kfg: $(SRCDIR)/default.kfg
	mkdir -p $(TEST_BINDIR)/ncbi
	cp $^ $@

KFG_SRC = \
	config-grammar \
	config-lex \
	config \
	kart \
	repository \
	report-kfg \
    keystore 

KFG_OBJ = \
	$(addsuffix .$(LOBX),$(KFG_SRC))

KFG_LIB = \
	-dkfs \
	-dklib

$(ILIBDIR)/libkfg.$(LIBX): $(INTERM_SRC) $(KFG_OBJ)
	$(LD) --slib -o $@ $^ $(KFG_LIB)

=== libs/kfs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/kfs

INT_LIBS = \
	libkfs

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# kfs
#
$(ILIBDIR)/libkfs: $(addprefix $(ILIBDIR)/libkfs.,$(ILIBEXT))

$(ILIBDIR)/libkfs-nommap: $(addprefix $(ILIBDIR)/libkfs-nommap.,$(LIBX))

KFS_CMN = \
	directory \
	arrayfile \
	file \
	sysdir \
	sysfile \
	sysmmap \
	syslockfile \
	sysdll \
	gzip \
	bzip \
	md5 \
	crc32 \
	arc \
	toc \
	tocentry \
	tocdir \
	tocfile \
	sra \
	tar \
	teefile \
	buffile \
	buffile-read \
	buffile-write \
	subfile \
	nullfile \
	countfile \
	dir_test \
	pagefile \
	pmem \
	readheadfile \
	ramfile \
	quickmount \
	report \
	lockfile \
	syslockfile \
	cacheteefile

KFS_SRC = \
	mmap \
	$(KFS_CMN)


KFS_OBJ = \
	$(addsuffix .$(LOBX),$(KFS_SRC))

KFS_LIB = \
	-dkproc \
	-dklib \
	-ddl \
	-dz \
	-dbz2

$(ILIBDIR)/libkfs.$(LIBX): $(KFS_OBJ)
	$(LD) --slib -o $@ $^ $(KFS_LIB)


#-------------------------------------------------------------------------------
# kff
#
ifeq (linux,$(OS))
$(ILIBDIR)/libkff: $(addprefix $(ILIBDIR)/libkff.,$(ILIBEXT))
else
$(ILIBDIR)/libkff:
	@ echo "not building libkff on "$(OS)
endif

KFF_SRC = \
	fileformat \
	ffext \
	ffkey \
	ffmagic

KFF_OBJ = \
	$(addsuffix .$(LOBX),$(KFF_SRC))

KFF_LIB = \
	-dkfg \
	-dklib

ifneq (win,$(OS))
	KFF_LIB += -lmagic
endif

$(ILIBDIR)/libkff.$(LIBX): $(KFF_OBJ)
	$(LD) --slib -o $@ $^ $(KFF_LIB)

=== libs/klib/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: all

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/klib

INT_LIBS = \
	libklib

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all: makedirs
	@ $(MAKE) -C $(SRCDIR)/judy all
	@ $(MAKE_CMD) $(TARGDIR)/all

std: makedirs
	@ $(MAKE) -C $(SRCDIR)/judy std
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE) -C $(SRCDIR)/judy std
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# all, std
#
$(TARGDIR)/all $(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean
	@ $(MAKE) -C $(SRCDIR)/judy clean

.PHONY: clean

#-------------------------------------------------------------------------------
# klib
#
$(ILIBDIR)/libklib: $(addprefix $(ILIBDIR)/libklib.,$(ILIBEXT))

KLIB_SRC = \
	text \
	utf8 \
	iso8859 \
	iso8859-1 \
	cp1252 \
	token \
	symtab \
	container \
	vector \
	namelist \
	vector_namelist \
	trie \
	pbstree \
	pbstree-impl.nopt \
	pbstree-impl.swap.nopt \
	bstpersist.nopt \
	ptrie.nopt \
	ptpersist.nopt \
	crc32 \
	md5 \
	SHA-32bit \
	SHA-64bit \
	qsort \
	ksort \
	bsearch \
	pack \
	unpack \
	vlen-encode \
	data-buffer \
	refcount \
	printf \
	status-rc-strings \
	status-rc \
	syserrcode \
	syswriter \
	out \
	status \
	log \
	writer \
	syslog \
	systime \
	rc-tbl \
	rc-idx-tbl \
	judy-vector \
	report

ifeq (win,$(OS))
	KLIB_SRC += sysalloc
endif

ifeq (dbg,$(BUILD))
	KLIB_SRC += debug
endif

KLIB_OBJ = \
	$(addsuffix .$(LOBX),$(KLIB_SRC))

KLIB_LIB = \
	-sjudy \
	-lm

$(ILIBDIR)/libklib.$(LIBX): $(KLIB_OBJ)
	$(LD) --slib -o $@ $^ $(KLIB_LIB)

=== libs/kns/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/kns

INT_LIBS = \
	libkns \
	libkurl

ALL_LIBS = \
	$(INT_LIBS)

TEST_TOOLS = \

include $(TOP)/build/Makefile.env

RWORKDIR = $(TOP)/$(MODULE)

#-------------------------------------------------------------------------------
# outer targets
#

# we are building it on all platforms now, because dependency on libcurl is removed
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# kns
#
$(ILIBDIR)/libkns: $(addprefix $(ILIBDIR)/libkns.,$(ILIBEXT))

KNS_NO_HTTP_SRC = \
	kns_manager \
	stream \
	stream-from-files \
	stream-from-streams \
	endpoint \
	sysendpoint \
	syssock \
	sysstream \
	sysmgr

KNS_SRC = \
	$(KNS_NO_HTTP_SRC) \
	http

KNS_OBJ = \
	$(addsuffix .$(LOBX),$(KNS_SRC))

KNS_LIB = \
    -lkfs \
	-dklib

$(ILIBDIR)/libkns.$(LIBX): $(KNS_OBJ)
	$(LD) --slib -o $@ $^ $(KNS_LIB)


#-------------------------------------------------------------------------------
# kurl
#
$(ILIBDIR)/libkurl: $(addprefix $(ILIBDIR)/libkurl.,$(ILIBEXT))

KURL_SRC = \
	KCurlFile \
	KCurlRequest \
	url-fetcher \
	url-fetcher-curl \
	entrez-fetcher

KURL_OBJ = \
	$(addsuffix .$(LOBX),$(KURL_SRC))

KURL_LIB = \
	-skns \
	-dkfs \
	-dklib \
	-dz

$(ILIBDIR)/libkurl.$(LIBX): $(KURL_OBJ)
	$(LD) --slib -o $@ $^ $(KURL_LIB)

=== libs/krypto/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

USE_GCC_IF_ICC = 1

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/krypto

INT_LIBS = \
	libkrypto

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

ifeq ($(OS),linux)
	INT_LIBS += libkryptotest
endif


#-------------------------------------------------------------------------------
# outer targets
#
# This differs from other sister Makefiles in needing three other symbols defined
# VEC_SUPPORTED, VECREG_SUPPORTED and AESNI_SUPPORTED
# The successive symbols are additive
# In order they are the compiler supports  the vector 'container' type,
# the preocessor has supported vector registers
# the processor supports the Intel AES-NI instruction set
#
# The prerequisite call to make compiler-test will have tried to compile objects
# that show such support if the objec can be made
all std: makedirs compiler-test
	@ $(MAKE_CMD) \
		VEC_SUPPORTED=$(shell if test -f $(OBJDIR)/compile-test.vec.$(LOBX) ; then echo "true"; else echo "false" ; fi) \
		VECREG_SUPPORTED=$(shell if test -f $(OBJDIR)/compile-test.vecreg.$(LOBX) ; then echo "true"; else echo "false" ; fi) \
		AESNI_SUPPORTED=$(shell if test -f $(OBJDIR)/compile-test.aes-ni.$(LOBX) ; then echo "true"; else echo "false" ; fi) \
		$(TARGDIR)/std || \
	( echo "reattempting without AES-NI instructions"; \
	  $(MAKE_CMD) \
		VEC_SUPPORTED=$(shell if test -f $(OBJDIR)/compile-test.vec.$(LOBX) ; then echo "true"; else echo "false" ; fi) \
		VECREG_SUPPORTED=$(shell if test -f $(OBJDIR)/compile-test.vecreg.$(LOBX) ; then echo "true"; else echo "false" ; fi) \
		AESNI_SUPPORTED=false \
		$(TARGDIR)/std ) || \
	( echo "reattempting without vector register instructions"; \
	  $(MAKE_CMD) \
		VEC_SUPPORTED=$(shell if test -f $(OBJDIR)/compile-test.vec.$(LOBX) ; then echo "true"; else echo "false" ; fi) \
		VECREG_SUPPORTED=false \
		AESNI_SUPPORTED=false \
		$(TARGDIR)/std ) || \
	( echo "reattempting without vector instructions"; \
	  $(MAKE_CMD) \
		VEC_SUPPORTED=false \
		VECREG_SUPPORTED=false \
		AESNI_SUPPORTED=false \
		$(TARGDIR)/std )

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))
#	@echo VEC_SUPPORTED $(VEC_SUPPORTED)
#	@echo VECREG_SUPPORTED $(VECREG_SUPPORTED)
#	@echo AESNI_SUPPORTED $(AESNI_SUPPORTED)

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# compiler-test
#
.PHONY: compiler-test $(TARGDIR)/compiler-test

# Silently try to compile three objects
compiler-test : makedirs
	@ $(MAKE_CMD) -i $(TARGDIR)/compiler-test >/dev/null 2>/dev/null


COMPILE_TEST_SRC = \
	compile-test.vec \
	compile-test.vecreg \
	compile-test.aes-ni

COMPILE_TEST_OBJ = \
	$(addsuffix .$(LOBX),$(COMPILE_TEST_SRC))

$(TARGDIR)/compiler-test : $(COMPILE_TEST_OBJ)
	@echo VEC_SUPPORTED $(VEC_SUPPORTED)
	@echo VECREG_SUPPORTED $(VECREG_SUPPORTED)
	@echo AESNI_SUPPORTED $(AESNI_SUPPORTED)

#-------------------------------------------------------------------------------
# define some additional compiler flags for special object file types
# currently only gcc is supported and it turns out only with 4.4.0 and up
# though other compilers could also be supported
ifeq ($(COMP),gcc)
CC_LISTING = -Wa,-ahlms=$(<D)/$(@F).list
_CC_AES_NI  = -funsafe-math-optimizations -mmmx -msse -msse2 -msse3 -mssse3 -msse4.1 -maes -Wa,-march=generic64+aes $(CC_LISTING)
_CC_VECREG  = -funsafe-math-optimizations -mmmx -msse -msse2 -msse3 -mssse3 -msse4.1 -Wa,-march=generic64+sse4 $(CC_LISTING)
_CC_VEC     = $(CC_LISTING)
else
_CC_LISTING =
_CC_AES_NI  =
_CC_VECREG  =
_CC_VEC     =
endif

ifeq ($(VEC_SUPPORTED),true)
CC_VEC = $(_CC_VEC)
else
CC_VEC =
endif

ifeq ($(VECREG_SUPPORTED),true)
CC_VECREG = $(_CC_VECREG)
else
CC_VECREG = 
endif

ifeq ($(AESNI_SUPPORTED),true)
CC_AES_NI = $(_CC_AES_NI)
else
CC_AES_NI = 
endif

# Rules for making objects using compiler vectors
compile-test.vec.pic.o : compile-test.c
	@ echo +++++ Making $@ using its own rule
	@ echo $@ $(_CC_VEC)
	$(CC) -o $@ -fPIC $(OPT) -D_LIBRARY -DUSEVEC $(_CC_VEC) $<


%.vec.$(LOBX): %.c
	$(CC) -o $@ -fPIC $(OPT) -D_LIBRARY -DUSEVEC $(CC_VEC) $<


# Rules for making objects using vectors in registers
compile-test.vecreg.pic.o : compile-test.c
	@ echo +++++ Making $@ using its own rule
	@ echo $@ $(_CC_VECREG)
	$(CC) -o $@ -fPIC $(OPT) -D_LIBRARY -DUSEVEC -DUSEVECREG $(_CC_VECREG) $<

%.vecreg.$(LOBX): %.c
	$(CC) -o $@ -fPIC $(OPT) -D_LIBRARY -DUSEVEC -DUSEVECREG $(CC_VECREG) $<


# Rules for making objects using AES-NI extensions vectors in registers
compile-test.aes-ni.pic.o : compile-test.c
	@ echo +++++ Making $@ using its own rule
	@ echo $@ $(_CC_AES_NI)
	$(CC) -o $@ -fPIC $(OPT) -D_LIBRARY -DUSEVEC -DUSEVECREG -DUSEAESNI $(_CC_AES_NI) $<

%.aes-ni.$(LOBX): %.c
	$(CC) -o $@ -fPIC $(OPT) -D_LIBRARY -DUSEVEC -DUSEVECREG -DUSEAESNI $(CC_AES_NI) $<



#-------------------------------------------------------------------------------
# krypto
#
$(ILIBDIR)/libkrypto: $(addprefix $(ILIBDIR)/libkrypto.,$(ILIBEXT))

ALL_LIB_SRC = \
	ciphermgr \
	wgaencrypt \
	encfile \
	encfilev2 \
	cipher \
	aes_core \
	aes-byte \
	cipher-byte \
	key \
	reencfile

LIB_SRC = \
	no-null-ncbi

TEST_LIB_SRC =  \
	null-ncbi \
	testcipher

ifeq ($(VEC_SUPPORTED),true)
ALL_LIB_SRC += \
	cipher-vec.vec \
	aes-ncbi.vec
LIB_SRC += \
	no-null-ncbi.vec
TEST_LIB_SRC += \
	null-ncbi.vec
else
ALL_LIB_SRC += \
	cipher-no-vec.vec
LIB_SRC += \
	no-null-ncbi.vec
TEST_LIB_SRC += \
	no-null-ncbi.vec
endif

ifeq ($(VECREG_SUPPORTED),true)
ALL_LIB_SRC += \
	cipher-vec.vecreg \
	aes-ncbi.vecreg
LIB_SRC += \
	no-null-ncbi.vecreg
TEST_LIB_SRC += \
	null-ncbi.vecreg
else
ALL_LIB_SRC += \
	cipher-no-vec.vecreg
LIB_SRC += \
	no-null-ncbi.vecreg
TEST_LIB_SRC += \
	no-null-ncbi.vecreg
endif

ifeq ($(AESNI_SUPPORTED),true)
ALL_LIB_SRC += \
	cipher-vec.aes-ni \
	aes-ncbi.aes-ni
LIB_SRC += \
	no-null-ncbi.aes-ni
TEST_LIB_SRC += \
	no-null-ncbi.aes-ni
else
ALL_LIB_SRC += \
	cipher-no-vec.aes-ni
LIB_SRC += \
	no-null-ncbi.aes-ni
TEST_LIB_SRC += \
	no-null-ncbi.aes-ni
endif


KRYPTO_SRC = $(ALL_LIB_SRC) $(LIB_SRC)

KRYPTO_OBJ = \
	$(addsuffix .$(LOBX),$(KRYPTO_SRC))

KRYPTO_LIB = \
	-dkfg \
	-dkfs \
	-dkproc \
	-dklib

$(ILIBDIR)/libkrypto.$(LIBX): $(KRYPTO_OBJ)
	$(LD) --slib -o $@ $^ $(KRYPTO_LIB)


#-------------------------------------------------------------------------------
# kryptotest
#

$(ILIBDIR)/libkryptotest: $(addprefix $(ILIBDIR)/libkryptotest.,$(ILIBEXT))

KRYPTOTEST_SRC = $(ALL_LIB_SRC)	$(TEST_LIB_SRC)

KRYPTOTEST_OBJ = \
	$(addsuffix .$(LOBX),$(KRYPTOTEST_SRC))

KRYPTOTEST_LIB = \
	-dkfg \
	-dkfs \
	-dkproc \
	-dklib

$(ILIBDIR)/libkryptotest.$(LIBX): $(KRYPTOTEST_OBJ)
	$(LD) --slib -o $@ $^ $(KRYPTOTEST_LIB)

=== libs/ncbi-vdb/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/ncbi-vdb

EXT_LIBS = \
	libncbi-vdb \
	libncbi-wvdb

ALL_LIBS = \
	$(EXT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(EXT_LIBS): makedirs
	@ $(MAKE_CMD) $(LIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(LIBDIR)/,$(EXT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# virtual db library
#
$(LIBDIR)/libncbi-vdb: $(addprefix $(LIBDIR)/libncbi-vdb.,$(LIBEXT))

ifeq (linux,$(OS))
LIBKFF = kff magic
LIBVDB_BLAST = vdb-blast
else
LIBKFF =
LIBVDB_BLAST =
endif

ifeq (win,$(OS))
LIBENTREZ =
LIBKQ =
LIBKXML =
else
LIBENTREZ =
LIBKQ = kq
LIBKXML = kxml kxfs
endif

VDB_LIB_CMN = \
	align-access \
	bz2 \
	kfg \
	kfs \
	klib \
	kproc \
	$(LIBKQ) \
	krypto \
	ksrch \
	$(LIBKXML) \
	kurl \
	vfs \
	z

VDB_LIB_RD = \
	$(VDB_LIB_CMN) \
	align-reader \
	ascp \
	$(EXT_SCHEMA_MODULES) \
	kdb \
	sradb \
	srareader \
	$(LIBVDB-BLAST) \
	vdb

VDB_OBJ = \
	$(addprefix $(ILIBDIR)/lib,$(addsuffix .a,$(VDB_LIB_RD)))

VDB_LIB = \
	$(addprefix -s,$(VDB_LIB_RD))

$(LIBDIR)/libncbi-vdb.$(SHLX): $(VDB_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $(VDB_LIB)

$(LIBDIR)/libncbi-vdb.$(LIBX): $(VDB_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $(VDB_LIB)

#-------------------------------------------------------------------------------
# update version
#
$(LIBDIR)/libncbi-wvdb: $(addprefix $(LIBDIR)/libncbi-wvdb.,$(LIBEXT))

VDB_LIB_RDWR = \
	$(VDB_LIB_CMN) \
	align-writer \
	waxf \
	wkdb \
	wsradb \
	wsraxf \
	wvdb \
	$(LIBENTREZ) \
	wvxf \
	wwgsxf

WVDB_OBJ = \
	$(addprefix $(ILIBDIR)/lib,$(addsuffix .a,$(VDB_LIB_RDWR)))

WVDB_LIB = \
	$(addprefix -s,$(VDB_LIB_RDWR))

$(LIBDIR)/libncbi-wvdb.$(SHLX): $(WVDB_OBJ)
	$(LD) --dlib --vers $(SRCDIR) -o $@ $(WVDB_LIB) -lxml2

$(LIBDIR)/libncbi-wvdb.$(LIBX): $(WVDB_OBJ)
	$(LD) --slib --vers $(SRCDIR) -o $@ $(WVDB_LIB)

=== libs/sra/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/sra

INT_LIBS = \
	libsraschema \
	libwsraschema \
	libsradb \
	libwsradb \
	libsrareader

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

VPATH += $(OBJDIR)

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean
	@ rm -f $(ILIBDIR)/libsra-schema.* $(ILIBDIR)/libwsra-schema.* $(ILIBDIR)/sra-dflt-schema*
	@ rm -f $(BINDIR)/libsra-schema.* $(BINDIR)/libwsra-schema.*

.PHONY: clean


#-------------------------------------------------------------------------------
# sradb embedded schema
#
$(ILIBDIR)/libsraschema: $(ILIBDIR)/libsraschema.$(LIBX)

$(ILIBDIR)/libwsraschema: $(ILIBDIR)/libwsraschema.$(LIBX)

SRA_DFLT_SCHEMA_LIBS = \
	-skapp \
	-svdb \
	$(ALWAYS_STATIC_SCHEMA_LIBS) \
	-salign-reader \
	-skdb \
	-svfs \
	-skurl \
	-sksrch \
	-skrypto \
	-skfg \
	-skfs \
	-sksproc \
	-sklib

SRA_DFLT_SCHEMA_OS_LIBS = \
	-ldl \
	-sz \
	-sbz2 \
	-lm

# set workdir for RUN_REMOTELY in rwin mode 
RWORKDIR=$(OBJDIR)

$(ILIBDIR)/sra-dflt-schema: sra-dflt-schema.$(OBJX)
	$(LD) --exe -o $@ $^ $(SRA_DFLT_SCHEMA_LIBS) $(SRA_DFLT_SCHEMA_OS_LIBS)

sra-schema.c: $(ILIBDIR)/sra-dflt-schema $(SRCDIR)/built-in.vschema $(TOP)/build/sra-dflt-schema.sh
	@ $(TOP)/build/sra-dflt-schema.sh $(BUILD_OS) "$(RUN_REMOTELY) $(ILIBDIR)/sra-dflt-schema" -o$@ -I$(TOP)/interfaces -T$(OBJDIR)/$@.d $(SRCDIR)/built-in.vschema
	cp $@ $(SRCDIR)
    
SRA_SCHEMA_SRC = \
	sraschema \
	sra-schema

SRA_SCHEMA_OBJ = \
	$(addsuffix .$(LOBX),$(SRA_SCHEMA_SRC))

WSRA_SCHEMA_OBJ = \
	$(addsuffix .$(LOBX),$(SRA_SCHEMA_SRC))

SRA_SCHEMA_LIB = \
	-dvdb \
	-dklib

WSRA_SCHEMA_LIB = \
	-dwvdb \
	-dklib

SRASCHEMA_SRC = \
	sraschema-stub \

WSRASCHEMA_SRC = \
	wsraschema-stub

SRASCHEMA_SRC += $(SRA_SCHEMA_SRC)
WSRASCHEMA_SRC += $(SRA_SCHEMA_SRC)

SRASCHEMA_OBJ = \
	$(addsuffix .$(LOBX),$(SRASCHEMA_SRC))

WSRASCHEMA_OBJ = \
	$(addsuffix .$(LOBX),$(WSRASCHEMA_SRC))

$(ILIBDIR)/libsraschema.$(LIBX): $(SRASCHEMA_OBJ) $(SRASCHEMA_DEPS)
	$(LD) --slib -o $@ $(SRASCHEMA_OBJ) $(SRA_SCHEMA_LIB)

$(ILIBDIR)/libwsraschema.$(LIBX): $(WSRASCHEMA_OBJ) $(WSRASCHEMA_DEPS)
	$(LD) --slib -o $@ $(WSRASCHEMA_OBJ) $(WSRA_SCHEMA_LIB)


#-------------------------------------------------------------------------------
# sradb library
#
$(ILIBDIR)/libsradb: $(addprefix $(ILIBDIR)/libsradb.,$(ILIBEXT))

SRADBCMN_SRC = \
	sramgr-cmn \
	sratbl-cmn \
	sracol \
	types \
    sracache

SRADB_SRC = \
	$(SRADBCMN_SRC) \
	sramgr \
	sratbl

SRADB_OBJ = \
	$(addsuffix .$(LOBX),$(SRADB_SRC))

SRADB_LIB = \
	-ssraschema \
	-dvdb \
	-dkdb \
	-dvfs \
	-dkfs \
	-lkfg \
	-dkproc \
	-dklib

$(ILIBDIR)/libsradb.$(LIBX): $(SRADB_OBJ)
	$(LD) --slib -o $@ $^ $(SRADB_LIB)


#-------------------------------------------------------------------------------
# update version
#
$(ILIBDIR)/libwsradb: $(addprefix $(ILIBDIR)/libwsradb.,$(ILIBEXT))

WSRADB_SRC = \
	$(SRADBCMN_SRC) \
	wsramgr \
	wsratbl

WSRADB_OBJ = \
	$(addsuffix .$(LOBX),$(WSRADB_SRC))

WSRADB_LIB = \
	-swsraschema \
	-dwvdb \
	-dwkdb \
	-dvfs \
	-dkfs \
	-lkfg \
	-dkproc \
	-dklib

$(ILIBDIR)/libwsradb.$(LIBX): $(WSRADB_OBJ)
	$(LD) --slib -o $@ $^ $(WSRADB_LIB)


#-------------------------------------------------------------------------------
# libsrareader
#
$(ILIBDIR)/libsrareader: $(addprefix $(ILIBDIR)/libsrareader.,$(ILIBEXT))

SRAREADER_SRC = \
	reader-cmn \
	reader-fastq \
	reader-sff \
	reader-illumina \
	reader-abi

SRAREADER_OBJ = \
	$(addsuffix .$(LOBX),$(SRAREADER_SRC))

SRAREADER_LIB = \
	-dsradb \
	-dkdb \
	-dklib

$(ILIBDIR)/libsrareader.$(LIBX): $(SRAREADER_OBJ)
	$(LD) --slib -o $@ $^ $(SRAREADER_LIB)

=== libs/vfs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = libs/vfs

INT_LIBS = \
	libvfs

ALL_LIBS = \
	$(INT_LIBS)

TEST_TOOLS = \

include $(TOP)/build/Makefile.env

RWORKDIR=$(TOP)/$(MODULE)

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: all std $(ALL_LIBS) $(TEST_TOOLS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean
	@ rm -f $(addsuffix *,$(addprefix $(TEST_BINDIR)/,$(TEST_TOOLS)))

.PHONY: clean

#-------------------------------------------------------------------------------
# vfs
#
$(ILIBDIR)/libvfs: $(addprefix $(ILIBDIR)/libvfs.,$(ILIBEXT))

VFS_SRC_CMN = \
	syspath \
	manager  \
	resolver \
    keyring \
    syskeyring

VFS_SRC = \
	path \
	$(VFS_SRC_CMN)

VFS_OBJ = \
	$(addsuffix .$(LOBX),$(VFS_SRC))

VFS_LIB = \
	-lkns \
	-lkurl \
	-lkns \
	-lkrypto \
	-lkfg \
	-lkfs \
	-lklib

$(ILIBDIR)/libvfs.$(LIBX): $(VFS_OBJ)
	$(LD) --slib -o $@ $^ $(VFS_LIB)

=== tools/cache-mgr/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(shell ../../build/abspath.sh ../..)
MODULE = tools/cache-mgr

include $(TOP)/build/Makefile.env

INT_TOOLS = \

EXT_TOOLS = \
	cache-mgr

ALL_TOOLS = \
	$(INT_TOOLS) \
	$(EXT_TOOLS)

#-------------------------------------------------------------------------------
# outer targets
#
all std: vers-includes
	@ $(MAKE_CMD) $(TARGDIR)/$@

$(ALL_TOOLS): vers-includes
	@ $(MAKE_CMD) $(BINDIR)/$@

.PHONY: all std $(ALL_TOOLS)

#-------------------------------------------------------------------------------
# all
#
$(TARGDIR)/all: \
	$(addprefix $(BINDIR)/,$(ALL_TOOLS))

.PHONY: $(TARGDIR)/all

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(BINDIR)/,$(EXT_TOOLS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# vers-includes
#
$(TARGDIR)/vers-includes: $(addsuffix .vers.h,$(EXT_TOOLS))

.PHONY: $(TARGDIR)/vers-includes

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# tag
#
tag: $(addsuffix _tag,$(ALL_TOOLS))

.PHONY: tag $(addsuffix _tag,$(ALL_TOOLS))

#-------------------------------------------------------------------------------
# cache-mgr
#
TOOL_SRC = \
	cache-mgr

TOOL_OBJ = \
	$(addsuffix .$(OBJX),$(TOOL_SRC))

TOOL_LIB = \
	-lkapp \
	-ssraschema \
	-dalign-reader \
	$(READONLY_SCHEMA_LIBS) \
	-lvdb \
	-lkdb \
	-lvfs \
	-lkurl \
	-lkrypto \
	-lkfg \
	-lkfs \
	-lksrch \
	-lkproc \
	-lklib \
	-lm

$(BINDIR)/cache-mgr: $(TOOL_OBJ)
	$(LD) --exe --vers $(SRCDIR) -o $@ $^ $(TOOL_LIB)

cache-mgr_tag:
	@ $(TOP)/build/tag-module.sh $(MODULE) cache-mgr $(TOOL_OBJ)

## sra-sdk 2.3.3-4~dfsg

=== debian/changelog ===
sra-sdk (2.3.3-4~dfsg-1) unstable; urgency=low

  [ Andreas Tille ]
  * New upstream version
  * debian/upstream: Add citation information
  * fix debian/watch
  * debian/control:
     - cme fix dpkg-control
     - debhelper 9
     - canonical Vcs fields
  * debian/copyright: Exclude external libraries
  * debian/rules:
     - Add get-orig-source target to call enhances uscan
     - remove override because upstream seems to do the correct thing now
     - libsra-schema seems to be not built any more in this version so
       drop the special handling of it
     - Reactivate deletion of libs/krypto/*.pic.o.list files to get a
       really clean source
  * debian/doc: USAGE is not provided by upstream any more
  * debian/patches/build-with-system-libbz2-libz.patch: Fix build problem
    (thanks to Gert Wollny <gw.fossdev@gmail.com> for the patch)
  * debian/sra-toolkit.install: There are neither mod?? nor wmod?? files
    shipped in this version any more - so remove these from dh_install
  * debian/patches/hardening.patch: Propagate Debian hardening options
    into build system
  * debian/patches/hardening-format-security.patch: Fix format strings in
    snprintf() calls
  * debian/watch: mangle version string
  * debian/sra-toolkit-libs0.lintian-overrides: override
    package-name-doesnt-match-sonames

  [ Charles Plessy ]
  32dd5cd Updated symbols file.

 -- Andreas Tille <tille@debian.org>  Wed, 23 Oct 2013 10:43:20 +0200

=== debian/control ===
Source: sra-sdk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               libbz2-dev,
               zlib1g-dev,
               libxml2-dev
Standards-Version: 3.9.4
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-med/sra-sdk.git
Vcs-Git: git://anonscm.debian.org/debian-med/sra-sdk.git
Homepage: http://trace.ncbi.nlm.nih.gov/Traces/sra/sra.cgi?view=software

Package: sra-toolkit
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: utilities for the NCBI Sequence Read Archive
 Tools for reading the SRA archive, generally by converting individual runs
 into some commonly used format such as fastq.
 .
 The textual dumpers "sra-dump" and "vdb-dump" are provided in this
 release as an aid in visual inspection. It is likely that their
 actual output formatting will be changed in the near future to a
 stricter, more formalized representation[s]. PLEASE DO NOT RELY UPON
 THE OUTPUT FORMAT SEEN IN THIS RELEASE.
 .
 The "help" information will be improved in near future releases, and
 the tool options will become standardized across the set. More documentation
 will also be provided documentation on the NCBI web site.
 .
 Tool options may change in the next release. Version 1 tool options
 will remain supported wherever possible in order to preserve
 operation of any existing scripts.

Package: sra-toolkit-libs0
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Libraries for the SRA Toolkit
 This package provides all libraries and modules for executing the
 NCBI SRA toolkit's programs.  This currently includes:
 .
  libkdb                # physical layer reading library
  libkfg                # configuration library
  libkfs                # file system library
  libklib               # support library
  libkproc              # process synchronization library
  libkq                 # cross-thread queue library
  libksproc             # single-threaded emulation library
  libksrch              # search algorithm library
  libkxfs               # XML to filesystem library
  libkxml               # XML container support library
  libload               # loader tool utility library
  libsra-schema         # weak-linked sra schema
  libsradb              # API for accessing sra
  libsrapath            # weak-link stubs for srapath
  libsrareader          # reader library
  libvdb                # virtual layer reading library
  libwkdb               # physical layer update library
  libwsradb             # update API for SRA
  libwvdb               # virtual layer update library

Package: sra-toolkit-libs-dev
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Development files for the NCBI SRA Toolkit's libraries
 This package provides development support files for the
 NCBI SRA Toolkit's libraries.
